Package org.pentaho.reporting.libraries.resourceloader.loader.zip

## Class ZipResourceLoader

- java.lang.Object
- - org.pentaho.reporting.libraries.resourceloader.loader.zip.ZipResourceLoader

- All Implemented Interfaces:
    `ResourceLoader`

      public class ZipResourceLoader
      extends java.lang.Object
      implements ResourceLoader

  Creation-Date: 05.04.2006, 15:53:21
  Author:
    Thomas Morgner

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.String` | `SCHEMA_NAME` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ZipResourceLoader()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `ResourceKey` | `createKey​(java.lang.Object value, java.util.Map factoryKeys)` | Creates a new resource key from the given object and the factory keys.
    `ResourceKey` | `deriveKey​(ResourceKey parent, java.lang.String path, java.util.Map factoryKeys)` | Derives a new resource key from the given key.
    `ResourceKey` | `deserialize​(ResourceKey bundleKey, java.lang.String stringKey)` | Creates a `ResourceKey` based off the `String` representation of the key.
    `boolean` | `isSupportedDeserializer​(java.lang.String data)` | Determines if the resource loader is capable of deserializing the serialized version of the ResourceKey.
    `boolean` | `isSupportedKey​(ResourceKey key)` | Checks, whether this resource loader implementation was responsible for creating this key.
    `ResourceData` | `load​(ResourceKey key)` | Loads the binary data represented by this key.
    `java.lang.String` | `serialize​(ResourceKey bundleKey, ResourceKey key)` | Serializes the resource key to a String representation which can be recreated using the `deserialize(ResourceKey)`method.``
    `java.net.URL` | `toURL​(ResourceKey key)` | Generates a `URL` version of the supplied `ResourceKey`.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### SCHEMA_NAME

          public static final java.lang.String SCHEMA_NAME

  - ### Constructor Detail

    - #### ZipResourceLoader

          public ZipResourceLoader()

  - ### Method Detail

    - #### isSupportedKey

          public boolean isSupportedKey​(ResourceKey key)

      Checks, whether this resource loader implementation was responsible for creating this key.
      Specified by:
        `isSupportedKey` in interface `ResourceLoader`
      Parameters:
        `key` -
      Returns:

    - #### createKey

          public ResourceKey createKey​(java.lang.Object value,
                                       java.util.Map factoryKeys)
                                throws ResourceKeyCreationException

      Creates a new resource key from the given object and the factory keys.
      Specified by:
        `createKey` in interface `ResourceLoader`
      Parameters:
        `value` -
        `factoryKeys` -
      Returns:
        the created key.
      Throws:
        `ResourceKeyCreationException` - if creating the key failed.

    - #### deriveKey

          public ResourceKey deriveKey​(ResourceKey parent,
                                       java.lang.String path,
                                       java.util.Map factoryKeys)
                                throws ResourceKeyCreationException

      Derives a new resource key from the given key. If neither a path nor new factory-keys are given, the parent key is returned.
      Specified by:
        `deriveKey` in interface `ResourceLoader`
      Parameters:
        `parent` - the parent
        `path` - the derived path (can be null).
        `factoryKeys` - the optional factory keys (can be null).
      Returns:
        the derived key.
      Throws:
        `ResourceKeyCreationException` - if the key cannot be derived for any reason.

    - #### toURL

          public java.net.URL toURL​(ResourceKey key)

      Description copied from interface: `ResourceLoader`
      Generates a `URL` version of the supplied `ResourceKey`.
      Specified by:
        `toURL` in interface `ResourceLoader`
      Parameters:
        `key` - the `ResourceKey` from which a `URL` will be created
      Returns:
        the URL representation of the `ResourceKey`

    - #### load

          public ResourceData load​(ResourceKey key)
                            throws ResourceLoadingException

      Description copied from interface: `ResourceLoader`
      Loads the binary data represented by this key.
      Specified by:
        `load` in interface `ResourceLoader`
      Returns:
      Throws:
        `ResourceLoadingException`

    - #### deserialize

          public ResourceKey deserialize​(ResourceKey bundleKey,
                                         java.lang.String stringKey)
                                  throws ResourceKeyCreationException

      Description copied from interface: `ResourceLoader`
      Creates a `ResourceKey` based off the `String` representation of the key. The `String` should have been created using the `serialize` method.
      Specified by:
        `deserialize` in interface `ResourceLoader`
        `stringKey` - the `String` representation of the `ResourceKey` @return a `ResourceKey` which matches the `String` representation
      Throws:
        `ResourceKeyCreationException` - indicates an error occurred in the creation or deserialization of the `ResourceKey`

    - #### serialize

          public java.lang.String serialize​(ResourceKey bundleKey,
                                            ResourceKey key)
                                     throws ResourceException

      Description copied from interface: `ResourceLoader`
      Serializes the resource key to a String representation which can be recreated using the `deserialize(ResourceKey)`method.``
      Specified by:
        `serialize` in interface `ResourceLoader`
      Returns:
        a `String`which is a serialized version of the `ResourceKey```
      Throws:
        `ResourceException` - indicates an error serializing the resource key

    - #### isSupportedDeserializer

          public boolean isSupportedDeserializer​(java.lang.String data)

      Description copied from interface: `ResourceLoader`
      Determines if the resource loader is capable of deserializing the serialized version of the ResourceKey.
      Specified by:
        `isSupportedDeserializer` in interface `ResourceLoader`
      Parameters:
        `data` - the serialized version of the resource key
      Returns:
        `true` if this `ResourceLoader` is capable of deserializing the serialized version of this resource key, `false` otherwise.